# -*- coding: utf-8 -*-
# Generated by Django 1.11.6 on 2020-04-01 08:24
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('customers', '0014_auto_20200331_1126'),
    ]

    operations = [
        migrations.CreateModel(
            name='ChargeApplied',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='created at')),
                ('amount', models.PositiveIntegerField(verbose_name='amount')),
                ('charge_applied', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='customers.Charge', verbose_name='charge')),
            ],
            options={
                'verbose_name': 'credit applied',
            },
        ),
        migrations.CreateModel(
            name='CreditApplied',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='created at')),
                ('amount', models.PositiveIntegerField(verbose_name='amount')),
                ('credit_applied', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='customers.Credit', verbose_name='credit')),
            ],
            options={
                'verbose_name': 'credit applied',
            },
        ),
        migrations.CreateModel(
            name='HistoricalChargeApplied',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('created_at', models.DateTimeField(blank=True, editable=False, verbose_name='created at')),
                ('amount', models.PositiveIntegerField(verbose_name='amount')),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('charge_applied', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Charge')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'historical credit applied',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
        ),
        migrations.CreateModel(
            name='HistoricalCreditApplied',
            fields=[
                ('id', models.IntegerField(auto_created=True, blank=True, db_index=True, verbose_name='ID')),
                ('created_at', models.DateTimeField(blank=True, editable=False, verbose_name='created at')),
                ('amount', models.PositiveIntegerField(verbose_name='amount')),
                ('history_id', models.AutoField(primary_key=True, serialize=False)),
                ('history_date', models.DateTimeField()),
                ('history_type', models.CharField(choices=[('+', 'Created'), ('~', 'Changed'), ('-', 'Deleted')], max_length=1)),
                ('credit_applied', models.ForeignKey(blank=True, db_constraint=False, null=True, on_delete=django.db.models.deletion.DO_NOTHING, related_name='+', to='customers.Credit')),
                ('history_user', models.ForeignKey(null=True, on_delete=django.db.models.deletion.SET_NULL, related_name='+', to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name': 'historical credit applied',
                'ordering': ('-history_date', '-history_id'),
                'get_latest_by': 'history_date',
            },
        ),
        migrations.AlterField(
            model_name='invoice',
            name='charge',
            field=models.ManyToManyField(blank=True, to='customers.ChargeApplied'),
        ),
        migrations.AlterField(
            model_name='invoice',
            name='credit',
            field=models.ManyToManyField(blank=True, to='customers.CreditApplied'),
        ),
    ]
